; Autor: Piotr Gecow
; Data: 16.10 .2009
; Version: 1.2.0
; Tested od GIMP 2.6 (Winows platform)
; Aktualizacja i spolszczenie dla Gimp 2.9: MareroQ 13.02.2016
; What new:
; - rebuild all
; - fix: no new layer in the memory at end
; - add: set-name 4 new layer

(define (script-fu-save-layers-to-PNG image png-comp dont-ask display-images backgnd backgnd-id)
	(let 	(
		(filename (car (gimp-image-get-filename image)))
		)
		(set! filename (strbreakup filename "."))
		(begin
			(if 
				(or 
					(= (strcmp (car (last filename)) "bz2") 0) 
					(= (strcmp (car (last filename)) "gz") 0)
				)
				(set! filename (butlast filename))
			)
			(set! filename (unbreakupstr (butlast filename) "."))
		)

    	(when (string=? filename "")
        	(set! filename  (string-append
        		(car (gimp-temp-name ""))
		        (car (gimp-image-get-name image))
		)
	)
)

(define (to-save-image dont-ask img new-name png-comp display-images)
	(to-save-png dont-ask img new-name png-comp)
	(cond 	((= display-images TRUE)
			(gimp-display-new img)
		)
		(else
		(gimp-image-delete img)
		)
	)

)

(define (to-save-png dont-ask img new-name png-comp)
	(file-png-save2 dont-ask
	img
	(car (gimp-image-get-active-layer img))
	(string-append new-name ".png")
	new-name
	TRUE png-comp FALSE TRUE FALSE FALSE TRUE FALSE FALSE)
)

(let loop 	(
		(layers2 (vector->list (cadr (gimp-image-get-layers image))))
		)
		(unless (null? layers2)
		(gimp-item-set-visible (car layers2) FALSE)
		(loop (cdr layers2))
		)
)


(let loop 	(
		(layers (vector->list (cadr (gimp-image-get-layers image))))
		(bufferName "")
		)
		
		(unless (null? layers)

		(gimp-item-set-visible (car layers) TRUE)

		(if (= backgnd TRUE)
		(gimp-item-set-visible backgnd-id TRUE)
		)

		(set! bufferName (car (gimp-edit-named-copy-visible image "export-selection_temp_buffer")))

		(gimp-item-set-visible (car layers) FALSE)

		(let*	(
			(img (car (gimp-edit-named-paste-as-new bufferName)))
			(layer-name (car (gimp-item-get-name (car layers))))
			(layer-id (car (gimp-image-get-active-drawable img))) 
			(new-name (string-append
				filename
				"_"
				layer-name))
			)
			
			(gimp-item-set-name layer-id layer-name)
			(gimp-image-set-filename img layer-name)
			(cond 	((= backgnd TRUE)
					(cond	((not (= (car layers) backgnd-id))
						(to-save-image dont-ask img new-name png-comp display-images)
						)
						(else
						(gimp-image-delete img)
						)
					)
				)
				(else
				; backgnd FALSE
				(to-save-image dont-ask img new-name png-comp display-images)
				)
			)


		)
		(loop (cdr layers)())
		))
	)
)

(script-fu-register "script-fu-save-layers-to-PNG"
	_"Zapisz warstwy (z tłem) jako PNG..."
	_"Zapis wszystkich warstw jako PNG. Opcjonalnie: dodanie tła lub otwarcie w nowych oknach. UWAGA: działa tylko dla zapisanego pliku."
	"Piotr Gecow (gacek56@tlen.pl)"
	"Piotr Gecow"
	"2009/2016"
	""
	SF-IMAGE "Foto" 1						;;image
	SF-ADJUSTMENT "Poziom kompresji (0--9)" '(9 0 9 1 10 0 0)	;;png-comp
	SF-TOGGLE _"Wyłączyć okno ustawień ekspotru obrazu jako PNG?" TRUE			;;dont-ask
	SF-TOGGLE _"Otworzyć warstwy w nowych oknach?" FALSE			;;display-images
	SF-TOGGLE _"Zapisać z tłem? (ustawionym jako pierwsza przezroczysta warstwa!)" FALSE			;;backgnd
	SF-LAYER _"Tło" TRUE)					;;backgnd-id

(script-fu-menu-register "script-fu-save-layers-to-PNG"
	_"<Image>/File/") 